Name:     mdadm
Version:  4.1
Release:  3
Summary:  The software RAID arrays user manage tools
License:  GPLv2+
URL:      http://www.kernel.org/pub/linux/utils/raid/mdadm/

Source0:  http://www.kernel.org/pub/linux/utils/raid/mdadm/mdadm-%{version}.tar.xz
Source1:  mdcheck-cron
Source2:  mdmonitor.service
Source3:  mdadm.conf

Patch1:  0001-Assemble-keep-MD_DISK_FAILFAST-and-MD_DISK_WRITEMOST.patch
Patch2:  0002-Document-PART-POLICY-lines.patch
Patch3:  0003-Grow-avoid-overflow-in-compute_backup_blocks.patch
Patch4:  0004-Grow-report-correct-new-chunk-size.patch
Patch5:  0005-Fix-spelling-typos.patch
Patch6:  0006-Detail.c-do-not-skip-first-character-when-calling-xs.patch
Patch7:  0007-Fix-reshape-for-decreasing-data-offset.patch
Patch8:  0008-mdmon-don-t-attempt-to-manage-new-arrays-when-termin.patch
Patch9:  0009-mdmon-wait-for-previous-mdmon-to-exit-during-takeove.patch
Patch10:  0010-Assemble-Fix-starting-array-with-initial-reshape-che.patch
Patch11:  0011-add-missing-units-to-examine.patch
Patch12:  0012-Create-Block-rounding-size-to-max.patch
Patch13:  0013-super-intel-Fix-issue-with-abs-being-irrelevant.patch
Patch14:  0014-imsm-close-removed-drive-fd.patch
Patch15:  0015-mdadm-force-a-uuid-swap-on-big-endian.patch
Patch16:  0016-Init-devlist-as-an-array.patch
Patch17:  0017-Don-t-need-to-check-recovery-after-re-add-when-no-I-.patch
Patch18:  0018-Manage-Remove-the-legacy-code-for-md-driver-prior-to.patch
Patch19:  0019-imsm-Correct-minimal-device-size.patch
Patch20:  0020-Detail-show-correct-bitmap-info-for-cluster-raid-dev.patch
Patch21:  0021-Assemble-print-error-message-if-mdadm-fails-assembli.patch
Patch22:  0022-Include-count-for-0-character-when-using-strncpy-to-.patch
Patch23:  0023-restripe-fix-ignoring-return-value-of-read-and-lseek.patch
Patch24:  0024-Block-overwriting-existing-links-while-manual-assemb.patch
Patch25:  0025-Detect-too-small-device-error-rather-than-underflow-.patch
Patch26:  0026-mdadm-Grow-prevent-md-s-fd-from-being-occupied-durin.patch
Patch27:  0027-mdadm-remove-Werror-to-fix-Werror-address-of-packed-.patch

BuildRequires:    systemd gcc binutils
Requires(post):   systemd coreutils
Requires(preun):  systemd
Requires(postun): systemd coreutils

%description
mdadm is a tool for managing Linux Software RAID arrays.
It can create, assemble, report on, and monitor arrays.
It can also move spares between raid arrays when needed.

%package        help
Summary:        Including man files for mdadm
Requires:       man
BuildArch:      noarch

%description    help
This contains man files for the using of mdadm.

%prep
%autosetup -n %{name}-%{version} -p1

%build
%make_build CXFLAGS="$RPM_OPT_FLAGS" LDFLAGS="$RPM_LD_FLAGS" SYSCONFDIR="%{_sysconfdir}" mdadm mdmon

%install
make DESTDIR=%{buildroot} MANDIR=%{_mandir} BINDIR=%{_sbindir} SYSTEMD_DIR=%{_unitdir} install install-systemd
install -Dp -m 755 misc/mdcheck %{buildroot}%{_sbindir}/mdcheck
install -Dp -m 644 %{SOURCE1} %{buildroot}%{_sysconfdir}/cron.d/mdcheck

#install mdmonitor.service from local file
install -D -m 644 %{SOURCE2} %{buildroot}%{_unitdir}

mkdir -p %{buildroot}%{_tmpfilesdir}
install -m 644  %{SOURCE3} %{buildroot}%{_tmpfilesdir}/mdadm.conf
install -d -m 710 %{buildroot}/var/run/mdadm/

%post
%systemd_post mdmonitor.service
/usr/bin/systemctl disable mdmonitor-takeover.service  >/dev/null 2>&1 || :

%preun
%systemd_preun mdmonitor.service

%postun
%systemd_postun_with_restart mdmonitor.service

%files
%doc ChangeLog  mdadm.conf-example
%license COPYING
%{_udevrulesdir}/*
%{_sbindir}/*
%{_unitdir}/*
/usr/lib/systemd/system-shutdown/mdadm.shutdown
%config(noreplace) %{_sysconfdir}/cron.d/mdcheck
%config(noreplace) %{_tmpfilesdir}/mdadm.conf 
%dir %{_localstatedir}/run/mdadm/

%files help
%{_mandir}/man*/*

%changelog
* Mon Jul 13 2020 Zhiqiang Liu <lzhq28@mail.ustc.edu.cn> - 4.1-3
- backport upstream bugfix patches

* Sun Jul 5 2020 Zhiqiang Liu <lzhq28@mail.ustc.edu.cn> - 4.1-2
- remove useless readme files.

* Tue Jun 30 2020 wuguanghao<wuguanghao3@huawei.com> - 4.1-1
- Type:enhancemnet
- ID:NA
- SUG:NA
- DESC: update mdadm version to 4.1-1 

* Mon Jun 29 2020 Zhiqiang Liu <liuzhiqiang26@huawei.com> - 4.1-rc2.0.11
- Type:enhancemnet
- ID:NA
- SUG:NA
- DESC: renumber patches

* Mon Jun 29 2020 Zhiqiang Liu <liuzhiqiang26@huawei.com> - 4.1-rc2.0.10
- Type:bugfix
- ID:NA
- SUG:NA
- DESC: remove -Werror to fix [-Werror=address-of-packed-member] problem

* Mon Mar 9 2020 hy <eulerstoragemt@huawei.com> - 4.1-rc2.0.9
- Type:bugfix
- ID:NA
- SUG:NA
- DESC: add a configuration file in /usr/lib/tmpfiles.d for creating the /run/mdadm directory during the boot process.

* Tue Mar 3 2020 hy <eulerstoragemt@huawei.com> - 4.1-rc2.0.8
- Type:bugfix
- ID:NA
- SUG:NA
- DESC:add ConditionPathExists in mdmonitor.service for resolving service failure during system startup

* Sun Jan 19 2020 hy <eulerstoragemt@huawei.com> - 4.1-rc2.0.7
- Type:bugfix
- ID:NA
- SUG:NA
- DESC:add the --syslog option while executing mdadm --scan command in mdmonitor.service

* Sat Jan 11 2020 openEuler Buildteam <buildteam@openeuler.org> - 4.1-rc2.0.6
- Type:enhancemnet
- ID:NA
- SUG:NA
- DESC:Repackage

* Tue Dec 31 2019 openEuler Buildteam <buildteam@openeuler.org> - 4.1-rc2.0.5
- Type:enhancement
- ID:NA
- SUG:NA
- DESC:use incremental assembly rules

* Wed Aug 28 2019 zhanghaibo <ted.zhang@huawei.com> - 4.1-rc2.0.4
- Type:enhancemnet
- ID:NA
- SUG:NA
- DESCi:openEuler Debranding

* Wed Aug 21 2019 zhanghaibo <ted.zhang@huawei.com> - 4.1-rc2.0.3
- Type:enhancemnet
- ID:NA
- SUG:NA
- DESCi:openEuler Debranding

* Thu Aug 8 2019 zhanghaibo <ted.zhang@huawei.com> - 4.1-rc2.0.2.h3
- Type:enhancemnet
- ID:NA
- SUG:NA
- DESCi:openEuler Debranding

* Sat Jun 22 2019 zhangsaisai<zhangsaisai@huawei.com> -  4.1-rc2.0.2.h2
- Type:bugfix
- ID:NA
- SUG:NA
- DESC:backport patch from community

* Wed Apr 10 2019 wangjufeng<wangjufeng@huawei.com> -  4.1-rc2.0.2.h1
- Type:bugfix
- ID:NA
- SUG:NA
- DESC:backport patch from community

- Package Initialization
